/***************************************************************************
 *   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#ifndef PAPYRUSOBJECT_H
#define PAPYRUSOBJECT_H

#include <sigc++/sigc++.h>

namespace Papyrus {

/**
@author Rick L Vinyard Jr
*/
class Object : public virtual sigc::trackable {
public:
    Object() { }

    virtual ~Object() { }

    sigc::signal<void, Object*, int>& signal_changed() {
        return m_signal_changed;
    }

protected:
    sigc::signal<void, Object*, int> m_signal_changed;
};

}

#endif
