/***************************************************************************
 *   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#ifndef PAPYRUSSHAPE_H
#define PAPYRUSSHAPE_H

#include <papyrus/drawable.h>
#include <papyrus/pattern.h>

namespace Papyrus {

/**
@author Rick L Vinyard Jr
*/
class Shape : public Drawable
{
public:
  Shape(Pattern fill=Pattern(), Pattern outline=Pattern());

    ~Shape();

    virtual void draw(cairo_t* cairo);

    virtual void draw_shape(cairo_t* cairo) = 0;

    void set_fill(Pattern fill);
    void set_fill(double r, double g, double b, double a=1.0);
    void set_outline(Pattern outline);
    void set_outline(double r, double g, double b, double a=1.0);

  protected:
    Pattern m_fill, m_outline;

};

}

#endif
